package com.zipcode.lab.learnerLab;

import java.util.List;

public abstract class People <PersonType extends Person> implements Iterable<PersonType>{

    private List<PersonType> personList;

    public People(List<PersonType> personList){
        this.personList = personList;

    }

    public People(PersonType ... args ){
        for(PersonType arg : args){
            this.personList.add(arg);
        }

    }

    public void add(PersonType pt){
        this.personList.add(pt);

    }

    public void remove(PersonType pt){
        this.personList.remove(pt);
    }

    public int size(){
        return this.personList.size();
    }

    public void clear(){
        this.personList.clear();
    }

    public void addAll(Iterable<PersonType> pts){
        for(PersonType pt : pts){
            this.personList.add(pt);
        }
    }

    public PersonType findById(long id) {
        PersonType person = null;
        for (PersonType pt : this.personList) {
            if (pt.getId() == id) {
                person = pt;
            }

        }
        return person;
    }

    public List findAll(){
        return personList;
    }
}


